% producer/consumer

-exports([main/0]).

main :-
    s_producer(100, S),
    s_consumer(0, 0, S)@fwd.

done(Count, Sum) :-
    fmt:format(1, 'sum(~d) = ~d~n', [Count, Sum], OK),
    stop(OK).

stop([]) :- sys:terminate.

s_producer(N, Out) :-
    N > 0 |
    R is isqrt(N << 16),
    Out := [R|Out1],
    N1 is N - 1,
    s_producer(N1, Out1).
s_producer(0, Out) :- Out := [].

s_consumer(Sum, Count, [Val|In1]) :-
    Sum1 is Sum + Val,
    Count1 is Count + 1,
    s_consumer(Sum1, Count1, In1).
s_consumer(Sum, Count, []) :-
    done(Count, Sum)@bwd.
