% Short circuit test
%
% from: "Parallel Logic Programming Techniques" (S. Taylor)

-exports([main/0]).

main :-
    network(100, _, done, AllDone),
    wait_for(AllDone).

wait_for(done) :- sys:terminate.  

network(N, Go, Left, Right) :-
    N > 0 |
    N1 is N - 1,
    link(Go, Left, Middle),
    network(N1, Go, Middle, Right)@fwd.
network(0, Go, C1, C2) :- 
    link(Go, C1, C2),
    Go := go.

link(go, C1, C2) :- C2 := C1.
